#include "funciones_graficas_basicas.c"
#include "pantallas.c"
#include "teclado.c"
#include "memoria.c"
unsigned short   x2;
int x1;
unsigned x, xp,x11,xp0,xp00,xp1,xp2;
unsigned adress, direccion,cont,multiplo=1,comp=1;
unsigned short t1,t;
short salir=0,zoom=0;

void inicia_grafico(void)
{
 delay_ms(5000);
 envia_comando(0x0000,0x40,2); // coloca direccion inicial de texto
 envia_comando(0x0200,0x42,2); // coloca direccion inicial de grafico
 envia_comando(0x001e,0x41,2); // coloca numero de direcciones de texto por linea
 envia_comando(0x001E,0x43,2); // coloca direccion de datos graficos
 envia_comando(0,0x80,0);      // Coloca modo encendido
 envia_comando(0x0002,0x22,2); // Coloca el registro de inicio (offset)
 envia_comando(0,0xa1,0);
 envia_comando(0,0x9c,0);      // Coloca modo del display (text on, grafic off, Cursor off)
 envia_comando(0x0000,0x24,2); // coloca direccion de texto
}

void mensaje(short y1, short x1, char *ptr)
{ short lon;
  adress = 0x0000 + (30*(y1-1)) + x1-1;
  lon = strlen(ptr);

  for(x=0; x<lon; x++)
     { envia_cadena(adress,*ptr);
       ptr++;
       adress++;
     }

}

void pixel(unsigned piy, unsigned pixi)
{  unsigned short xb, pixeles[]={0xff,0xfe,0xfd,0xfc,0xfb,0xfa,0xf9,0xf8};
  unsigned adelante, ad, xc;
  t = pixi;
  t1 = t>>3;
  piy--;
  adress = 0x0200 + t1 + piy*30;
  t = pixi - (t1*8);

  // colocamos la direccion y enviamos la posicion del pixel a encender
  Delay_ms(1);
  envia_comando(adress,0x24,2);
  Delay_ms(1);
  escribe_comando(pixeles[t]);

   // borramos 1 direcciones adelante
  adelante = ( (adress-0x0200)%30)+2;
  if(piy<54)
     xc=1052;
  else
     if(piy<91)
        xc=1620;
     else
        xc=2760;
  adress = xc+adelante;
  if(adress != ad)
    {  ad = adress;
       for(xb=0;xb<36; xb++)
          { adress = adress + 30;
            envia_dato(adress,0);
          }
    }
}
void pixel2(unsigned piy, unsigned pixi)
{  unsigned short xb, pixeles[]={0xff,0xfe,0xfd,0xfc,0xfb,0xfa,0xf9,0xf8};
  unsigned adelante, ad, xc;
  t = pixi;
  t1 = t>>3;
  piy--;
  adress = 0x0200 + t1 + piy*30;
    t = pixi - (t1*8);
 // colocamos la direccion y enviamos la posicion del pixel a encender
  Delay_ms(1);
  envia_comando(adress,0x24,2);
  Delay_ms(1);
  escribe_comando(pixeles[t]);
}

void borra_pixel(unsigned piy, unsigned pixi)
{  unsigned short xb, pixeles[]={0xff,0xfe,0xfd,0xfc,0xfb,0xfa,0xf9,0xf8};
  unsigned adelante, ad, xc;
  t = pixi;
  t1 = t>>3;
  piy--;
  adress = 0x0200 + t1 + piy*30;
  // colocamos  la direccion y enviamos la posicion del pixel a encender
  Delay_ms(1);
  envia_dato(adress,0);

}

void cargar_imagen(unsigned char const panta[3840])
{ unsigned char dato;
 adress = 0x0200;
  for(xp=0; xp<128; xp++)
     { for(x=0;x<30;x++)
         { //if(panta==1)
              dato =  panta[x+xp*30];
            //else
             // dato = presenta[x+xp*30];
           envia_dato(adress,dato);
           adress++;
         }
//       adress = adress + 14;
     }
}

void carga_corazon(const unsigned char *ap)
{ unsigned char dato;
  unsigned short xz;
  adress = 0x021c;
  for(xp=0; xp<10; xp++)
     { for(xz=0;xz<2;xz++)
         { dato = *ap++;
           envia_dato(adress,dato);
           adress++;
         }
       adress = adress + 28;
     }
}


void borra_memoria(unsigned short m1)   // 0 = grafico;  1 = texto
{ int fin;
  if(m1==0)
    { adress = 0x0200;
      fin = 0x3fff;
    }
  else
    { adress = 0x0000;
      fin = 0x0200;
    }
  for(xp=0; xp<fin; xp++)
     {
           envia_dato(adress,0);
           adress++;
     }
}

void borra_linea(unsigned short lin)
{
  adress = 0x0000;
  adress = adress + (lin-1) * 30;
  for(xp=0; xp<30; xp++)
     {
           envia_dato(adress,0);
           adress++;
     }
}


void linea(unsigned short x1, unsigned short y1, unsigned short x2,unsigned short y2)
{ unsigned short xa, ya;
 for(xa=y1;xa<y2;xa++)
    { pixel(x1,xa);
      if(xa%10==0)
        xa+=5;
    }
}

void aumenta_contador(void)
{
   PORTA.F4=1;   //Pulso de incremento de direcion en memoria
   asm nop;
   PORTA.F4=0;
}

void reset_contadores(void)
{
 PORTA.F5 = 1;
 Delay_us(50);
 PORTA.F5 = 0;
}
void timer(void)
 {
              T0CON=0b11000110;
              INTCON=0b10100100;
              TMR0L =63;
 }

void menu(void)
  {
  mensaje(2,2,"ELECTROCARDIOGRAFO DIGITAL");
  mensaje(6,2,"1.-ENTER PARA CAPTURAR");
  mensaje(9,4,"2.-DERECHA PARA LEER");
  }
  
void mover_cursor(void)
  {
  mensaje(13,1,"*DERECHA O IZQUIERDA");
  mensaje(14,1," PARA MOVER CURSOR");
  mensaje(16,8,"**ARRIBA PARA AJUSTAR");
  }
void mensajezoom(void)
{
      mensaje(13,2,"DERECHA PARA CONTINUAR");
      mensaje(15,2,"ENTER PARA SELECCION");
}
  
  void inicio(void);
  void leer_muestra(void);
  void capturar_muestra(void);
  void grafica(short a,short b, short c,short d);
  void iniciozoom(unsigned con);
  void zoomx(unsigned con,unsigned xi,unsigned xf);
  void graficarzoom(unsigned xi, unsigned xf);
  unsigned cursor(void);
  unsigned cursor1(void);
unsigned short corazon;
/*****************************************************//////////////////////
void main(void)
{ //double y;

 unsigned i=0;
 char cad[10];
 TRISC=0B11000000;
 PORTC=0b00100000;
 TRISB = 0;
 PORTB = 0;
 TRISA= 0b0000001;
 ADCON1 = 14;
 porta=0b00000100;
 porta.f6=1;
 corazon= 0;

 inicio();
  while(1)
{
  menu();
  do{teclado();}while(!(portb==16||portb==2));
  switch(portb)
    {
      case 16:    reset_contadores();
                  capturar_muestra();
                  break;

       case 2:    leer_muestra();
                      break;
      default:    break;

    }

    TRISB=0B00000000;
    PORTA.F3=0;
    borra_memoria(0);
    borra_memoria(1);
  }// fin del while
} // fin del main

void inicio(void)
{
reset_contadores();
delay_ms(300);
inicia_grafico();
borra_memoria(0);
cargar_imagen(corazon3);
delay_ms(10000);
for(x1=0; x1<5; x1++)
{ carga_corazon(coraz);
  Delay_ms(850);
  carga_corazon(cora);
  Delay_ms(850);
}
borra_memoria(0);
borra_memoria(1);

  { mensaje(4,5,"VISUALIZADOR DE SENHAL");
    mensaje(6,9,"CARDIACA");
    Delay_ms(2000);
  }


borra_memoria(0);
borra_memoria(0);
borra_memoria(1);


}

//funcion para leer del puerto analogico cada 10 ms
void interrupt ( void )
{
TMR0L=63;
INTCON.F2 = 0;
cont++;
      xp0 = ADC_Read(0);
      if(xp0>1023)
         xp0=1023;
      escribe_memoria(xp0);

}

void capturar_muestra(void)
{
                 multiplo=1;
                 timer();
                 x = 1;
                 xp0 = 512;
                 restaurar();
                 borra_linea(6);
                 borra_linea(9);
                 reset_contadores();
                 for(x1=0;x1<320;x1++)
                   {
                    //1
                  // escribe_memoria(xp0);

                    if(x1==multiplo)
                      {
                 delay_ms(50);
                 grafica(36,17,29,10);


                   if(multiplo==1) multiplo=0;
                   multiplo=multiplo+2;   //linea para cambiar n de muestras a graficar
                   if(multiplo>=999) multiplo=0;
                   //x++;
                      }
                  //pixel(26+(25-xp1/20),x);
                  //pixel(26+(25-xp2/20),x);
                  xp00 = xp0;
                  x++;
                  if(x==240) x = 1;


                  }
                  T0CON=0b00000000;
                  INTCON=0b00000000;
                  reset_contadores();
                  x=1;
                  xp0=512;

                     borra_memoria(0);
                     borra_memoria(1);
                   // filtrado();

}
void leer_muestra(void)
{
unsigned leer;
unsigned i=0;
unsigned con=0,num;
 char text[8] ;
    multiplo=1;
    x = 1;
    xp0 = 512;
    restaurar();
    borra_linea(5);
    borra_linea(6);
    borra_linea(9);
    reset_contadores();
    TRISB = 0x0ff;       //modo entrada
    PORTA.F3=1;          //desactivar buffer
    for(x1=0;x1<960;x1++)
     {
       con++;
       con++;
       xp0=lee_memoria();
       // grafica(36,17,29,10);
        //num=xp0;
      if(x1==multiplo)
        {
          //delay_ms(25);
          grafica(36,17,29,10);
          
          if(multiplo==1) multiplo=0;
          multiplo=multiplo+4;
          if(multiplo>=959) multiplo=0;
          
          x++;
         }
       //delay_ms(200);
       //IntToStr(num,text);
       //mensaje(14,2,text);                // pixel(26+(25-xp1/20),x);
                       // pixel(26+(25-xp2/20),x);
      xp00 = xp0;
       //x++;
       delay_ms(10);
         if(x==240)
            {  x = 1;
               iniciozoom(con);
               delay_ms(10);
            }
      delay_ms(10);
      TRISB = 0x0ff;    //modo entrada
      PORTA.F3=1;       //deshabilito buffer
    }
          asm nop;
          portc.f5=1;////
          portc.f6=1;//deshabilitar memoria
          portc.f7=1;////
          delay_ms(5000);
          reset_contadores();
          delay_ms(10);
}

void grafica(short a,short b, short c,short d)
{
      PORTA.F3=0;       //activar buffer
      asm{nop;nop;nop;nop}
      TRISB = 0x000;    //modo salida

       if(xp0<xp00)
       {
        for(x11=xp0;x11<xp00; x11+=d)
           pixel(a+(b-x11/c),x);
                      // tercera seal 110 (128- 92)
                      // segunda seal 73  ( 91- 55)
                      // primer  seal 36  ( 54- 18)
       }
      else
       { for(x11=xp00;x11<xp0; x11+=d)
             pixel(a+(b-x11/c),x);
       }
      pixel(a+(b-x11/c),x);

      if(xp00<xp0 && corazon == 1)
       {
        corazon = 0;
        carga_corazon(coraz);
       }
      else
       if(xp00>xp0 && corazon == 0)
        { corazon = 1;
          carga_corazon(cora);
        }

}
void iniciozoom(unsigned con)
{
unsigned xi=0,xf=0;

               mensajezoom();
               while(salir==0)
               {
                do{
                teclado();
                if(portb.f4==1)   //ZOOM
                {
                 zoom=1;
                 salir=1;
                 }
                if(portb.f1==1)  //continuar lecctura
                salir=1;
                }while(portb==0);
                restaurar();
               }

               if(zoom==1)
               {
               borra_linea(13);
               borra_linea(15);
               xi=cursor(); ///////////////////////////////////////////////////////
               asm nop;
               xf=cursor1();
               reset_contadores();
               asm nop;
               zoomx(con,xi,xf);
               asm nop;
               borra_memoria(0);
               asm nop;
               mensaje(2,2,"ELECTROCARDIOGRAFO DIGITAL");
               asm nop;
               }
               salir=0;
               zoom=0;
               

}

 void zoomx(unsigned con, unsigned xi, unsigned xf)
 {  short sal=1, a=0;
    unsigned start=0, stop=0,i=0,j=0,contador=0;
    //start=con-480+xi*2;
    start=con-1920+(xi)*8;
    xi=xi*4;
    xf=xf*4;
    //stop=con-960-xf*2;
    
   while(sal==1)
 {

    if(a==1)
    {
      borra_memoria(0);
      mensaje(2,2,"ELECTROCARDIOGRAFO DIGITAL");
      reset_contadores();
      for(i=0;i<start;i++)
      {asm nop;
          aumenta_contador();
          }
       ////////////////////
       delay_ms(1000);
       graficarzoom(xi,xf);/////////////////

       ////////////////////
      a=0;

    }
    restaurar();
    mensaje(16,10,"ARRIBA PARA SALIR");


   do
   {

    teclado();
    if(portb.f2==1)  //SALIR
    {sal=0;a=0;}
    if(portb.f4==1) ///ZOOM
     {a=1;}
     delay_ms(1);
   }while(portb==0);
   restaurar();
   
   //borra_linea(16);
 }
 reset_contadores();
// contador=(240-xf)*2;
       for(i=0;i<con;i++)
          { asm nop;
          aumenta_contador();}
 

 }
 
 void graficarzoom(unsigned xi, unsigned xf)
 {
   unsigned j=0;
   long graf=0;

              x = 1;
              xp0 = 512;
             TRISB = 0x0ff;       //modo entrada
             asm {nop nop nop}
             PORTA.F3=1;          //desactivar buffer glcd
             asm {nop nop nop}
             porta.f2=1;
             asm {nop nop nop}
              portc.f5=1;//
              asm {nop nop nop}
              portc.f6=1;//deshabilitar memoria
              asm {nop nop nop}
              portc.f7=1;//
              asm {nop nop nop}
             for(j=xi;j<xf;j++)              
             {
             graf=lee_memoria();
             xp0=graf;
             if(xp0>=1023)
             xp0=1023;
             if(xp0>=0&&xp0<=1023)
             //grafica(80,17,15,10);
             grafica(36,17,29,10);
                      //  pixel(26+(25-xp1/20),x);
                     //  pixel(26+(25-xp2/20),x);
             xp00 = xp0;
             x++;
             if(x==240)
             {
               x = 1;
             }
             TRISB = 0x0ff;    //modo entrada
             asm {nop nop nop}
             PORTA.F3==1;       //deshabilito buffer
             } 
             

 }

unsigned cursor(void)
{
unsigned y=0,xx=2,salir=1,z=0,cont=2,cont1=2,j=0;
  for(j=0;j<240;j++)
       pixel2(70,j);
 mover_cursor();
 while(salir==1)
 {
 
 if(cont1<cont)
 {
    z=cont1+1;
 }
 if(xx==cont)
    z=cont-1;
 for(y=60;y<=69;y++)
  borra_pixel(y,z);

 for(y=60;y<=69;y++)
  pixel2(y,xx);
  do
  {
   delay_ms(10);
   teclado();
   if(portb.f1==1)  //derecha
      {xx++;
      cont=xx;}
   if(portb.f0==1)  //izquierda
      {
      xx--;
      cont1=xx;
      }
  if(portb.f2==1)
    salir=0;
  }
  while(portb==0);
  restaurar();


 }
  borra_linea(16);
return xx;
}

unsigned cursor1(void)
{
 unsigned y=0,xx=238,sal=1,z=0,cont3=238,cont4=238;
 mensaje(16,8,"**ABAJO PARA AJUSTAR");
 while(sal==1)
 {
    if(cont4<cont3)
    {
    z=cont4+1;
    }
    if(xx==cont3)
    z=cont3-1;
 /*borrar cursor*/
 for(y=60;y<=69;y++)
  borra_pixel(y,z);
 /*dibujar cursor*/
 for(y=60;y<=69;y++)
  pixel2(y,xx);

   do
   {
     delay_ms(10);
     teclado();
     if(portb.f1==1) //derecha
      {xx++;
      cont3=xx;}
     if(portb.f0==1) //izquierda
      {
      xx--;
      cont4=xx;
      }
    if(portb.f3==1)
    sal=0;
   }
   while(portb==0);
  restaurar();

 }
  borra_linea(13);
  borra_linea(14);
  borra_linea(16);
  mensaje(15,8,"ENTER PARA ZOOM");
 return xx;
}
