#define WR PORTC.F0
#define RD PORTC.F1
#define CE PORTC.F2
#define CD PORTA.F1


void escribe_dato(short d)
{
 RD = 1;
 WR = 0;
 CD = 0;
 PORTB = d;
 CE = 0;
 CE = 1;
}

void escribe_comando(short d)
{
 RD = 1;
 WR = 0;

 CD = 1;
 PORTB = d;
 CE = 0;
 CE = 1;
}


void envia_comando(int dat, short comand, short num)
{
 Delay_us(50);
 if(num != 0)
   { escribe_dato(dat);
     Delay_us(50);
     if(num == 2)
       { escribe_dato(dat>>8);
         Delay_us(50);
       }
   }
 escribe_comando(comand);
}

void envia_cadena(int direc,char das)
{
  Delay_us(50);
  envia_comando(direc,0x24,2);
  Delay_us(50);
  escribe_dato(das-32);
  Delay_us(50);
  escribe_comando(0xC4);
}

void envia_dato(int dir, char da)
{
  Delay_us(50);
  envia_comando(dir,0x24,2);
  Delay_us(50);
  escribe_dato(da);
  Delay_us(50);
  escribe_comando(0xC4);

}

unsigned short lee_dato(int dir1)
{ unsigned short r;
  Delay_us(50);
  envia_comando(dir1,0x24,2);
  Delay_us(50);
  escribe_comando(0xC5);
  Delay_us(50);
  TRISB = 255;
  RD = 0;
  WR = 1;
  CD = 0;
  CE = 0;
  r = PORTC;
  CE = 1;
  TRISB = 0;
  PORTA = r;
  Delay_us(5000);
  return r;
  
}

